dutil.c File Reference

Matrix utility functions. More...

`#include <math.h>`
`#include "slu_ddefs.h"`
Include dependency graph for dutil.c:

## Functions

void | dCreate_CompCol_Matrix (SuperMatrix *A, int m, int n, int_t nnz, double *nzval, int_t *rowind, int_t *colptr, Stype_t stype, Dtype_t dtype, Mtype_t mtype)
| Supernodal LU factor related. More...
void | dCreate_CompRow_Matrix (SuperMatrix *A, int m, int n, int_t nnz, double *nzval, int_t *colind, int_t *rowptr, Stype_t stype, Dtype_t dtype, Mtype_t mtype)
void | dCopy_CompCol_Matrix (SuperMatrix *A, SuperMatrix *B)
| Copy matrix A into matrix B. More...
void | dCreate_Dense_Matrix (SuperMatrix *X, int m, int n, double *x, int ldx, Stype_t stype, Dtype_t dtype, Mtype_t mtype)
void | dCopy_Dense_Matrix (int M, int N, double *X, int ldx, double *Y, int ldy)
void | dCreate_SuperNode_Matrix (SuperMatrix *L, int m, int n, int_t nnz, double *nzval, int_t *nzval_colptr, int_t *rowind, int_t *rowind_colptr, int *col_to_sup, int *sup_to_col, Stype_t stype, Dtype_t dtype, Mtype_t mtype)
void | dCompRow_to_CompCol (int m, int n, int_t nnz, double *a, int_t *colind, int_t *rowptr, double **at, int_t **rowind, int_t **colptr)
| Convert a row compressed storage into a column compressed storage. More...
void | dPrint_CompCol_Matrix (char *what, SuperMatrix *A)
| Routines for debugging. More...
void | dPrint_SuperNode_Matrix (char *what, SuperMatrix *A)
void | dPrint_Dense_Matrix (char *what, SuperMatrix *A)
void | dprint_lu_col (char *msg, int jcol, int pivrow, int_t *xprune, GlobalLU_t *Glu)
| Diagnostic print of column "jcol" in the U/L factor. More...
void | dcheck_tempv (int n, double *tempv)
| Check whether tempv[] == 0. This should be true before and after calling any numeric routines, i.e., "panel_bmod" and "column_bmod". More...
void | dGenXtrue (int n, int nrhs, double *x, int ldx)
void | dFillRHS (trans_t trans, int nrhs, double *x, int ldx, SuperMatrix *A, SuperMatrix *B)
| Let rhs[i] = sum of i-th row of A, so the solution vector is all 1's. More...
void | dfill (double *a, int alen, double dval)
| Fills a double precision array with a given value. More...
void | dinf_norm_error (int nrhs, SuperMatrix *X, double *xtrue)
| Check the inf-norm of the error vector. More...
void | dPrintPerf (SuperMatrix *L, SuperMatrix *U, mem_usage_t *mem_usage, double rpg, double rcond, double *ferr, double *berr, char *equed, SuperLUStat_t *stat)
| Print performance of the code. More...
int | print_double_vec (char *what, int n, double *vec)

## Detailed Description

Copyright (c) 2003, The Regents of the University of California, through Lawrence Berkeley National Laboratory (subject to receipt of any required approvals from U.S. Dept. of Energy)

All rights reserved.

The source code is distributed under BSD license, see the file License.txt at the top-level directory.

    -- SuperLU routine (version 3.1) --
    Univ. of California Berkeley, Xerox Palo Alto Research Center,
    and Lawrence Berkeley National Lab.
    August 1, 2008

    Copyright (c) 1994 by Xerox Corporation.  All rights reserved.

    THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY
    EXPRESSED OR IMPLIED.  ANY USE IS AT YOUR OWN RISK.

    Permission is hereby granted to use or copy this program for any
    purpose, provided the above notices are retained on all copies.
    Permission to modify the code and to distribute modified code is
    granted, provided the above notices are retained, and a notice that
    the code was modified is included with the above copyright notice.

## Function Documentation

## dcheck_tempv()

void dcheck_tempv | ( | int | n,
|  | double * | tempv
| ) |  |

## dCompRow_to_CompCol()

void dCompRow_to_CompCol | ( | int | m,
|  | int | n,
|  | int_t | nnz,
|  | double * | a,
|  | int_t * | colind,
|  | int_t * | rowptr,
|  | double ** | at,
|  | int_t ** | rowind,
|  | int_t ** | colptr
| ) |  |

Here is the call graph for this function:

## dCopy_CompCol_Matrix()

void dCopy_CompCol_Matrix | ( | SuperMatrix * | A,
|  | SuperMatrix * | B
| ) |  |

## dCopy_Dense_Matrix()

void dCopy_Dense_Matrix | ( | int | M,
|  | int | N,
|  | double * | X,
|  | int | ldx,
|  | double * | Y,
|  | int | ldy
| ) |  |

Copies a two-dimensional matrix X to another matrix Y.

## dCreate_CompCol_Matrix()

void dCreate_CompCol_Matrix | ( | SuperMatrix * | A,
|  | int | m,
|  | int | n,
|  | int_t | nnz,
|  | double * | nzval,
|  | int_t * | rowind,
|  | int_t * | colptr,
|  | Stype_t | stype,
|  | Dtype_t | dtype,
|  | Mtype_t | mtype
| ) |  |

## dCreate_CompRow_Matrix()

void dCreate_CompRow_Matrix | ( | SuperMatrix * | A,
|  | int | m,
|  | int | n,
|  | int_t | nnz,
|  | double * | nzval,
|  | int_t * | colind,
|  | int_t * | rowptr,
|  | Stype_t | stype,
|  | Dtype_t | dtype,
|  | Mtype_t | mtype
| ) |  |

## dCreate_Dense_Matrix()

void dCreate_Dense_Matrix | ( | SuperMatrix * | X,
|  | int | m,
|  | int | n,
|  | double * | x,
|  | int | ldx,
|  | Stype_t | stype,
|  | Dtype_t | dtype,
|  | Mtype_t | mtype
| ) |  |

## dCreate_SuperNode_Matrix()

void dCreate_SuperNode_Matrix | ( | SuperMatrix * | L,
|  | int | m,
|  | int | n,
|  | int_t | nnz,
|  | double * | nzval,
|  | int_t * | nzval_colptr,
|  | int_t * | rowind,
|  | int_t * | rowind_colptr,
|  | int * | col_to_sup,
|  | int * | sup_to_col,
|  | Stype_t | stype,
|  | Dtype_t | dtype,
|  | Mtype_t | mtype
| ) |  |

## dfill()

void dfill | ( | double * | a,
|  | int | alen,
|  | double | dval
| ) |  |

## dFillRHS()

void dFillRHS | ( | trans_t | trans,
|  | int | nrhs,
|  | double * | x,
|  | int | ldx,
|  | SuperMatrix * | A,
|  | SuperMatrix * | B
| ) |  |

Here is the call graph for this function:

## dGenXtrue()

void dGenXtrue | ( | int | n,
|  | int | nrhs,
|  | double * | x,
|  | int | ldx
| ) |  |

## dinf_norm_error()

void dinf_norm_error | ( | int | nrhs,
|  | SuperMatrix * | X,
|  | double * | xtrue
| ) |  |

## dPrint_CompCol_Matrix()

void dPrint_CompCol_Matrix | ( | char * | what,
|  | SuperMatrix * | A
| ) |  |

## dPrint_Dense_Matrix()

void dPrint_Dense_Matrix | ( | char * | what,
|  | SuperMatrix * | A
| ) |  |

## dprint_lu_col()

void dprint_lu_col | ( | char * | msg,
|  | int | jcol,
|  | int | pivrow,
|  | int_t * | xprune,
|  | GlobalLU_t * | Glu
| ) |  |

## dPrint_SuperNode_Matrix()

void dPrint_SuperNode_Matrix | ( | char * | what,
|  | SuperMatrix * | A
| ) |  |

## dPrintPerf()

void dPrintPerf | ( | SuperMatrix * | L,
|  | SuperMatrix * | U,
|  | mem_usage_t * | mem_usage,
|  | double | rpg,
|  | double | rcond,
|  | double * | ferr,
|  | double * | berr,
|  | char * | equed,
|  | SuperLUStat_t * | stat
| ) |  |

## print_double_vec()

int print_double_vec | ( | char * | what,
|  | int | n,
|  | double * | vec
| ) |  |